import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ProgressDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private boolean m_Cancelled = false;
	private JLabel lblCaption;
	private JProgressBar progressBar;
	private JLabel lblProcessed;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ProgressDialog dialog = new ProgressDialog();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public ProgressDialog() {
		setTitle("Operation progress");
		setBounds(100, 100, 320, 137);
		getContentPane().setLayout(null);
		
		lblCaption = new JLabel("Processing object \"Object 1\"");
		lblCaption.setBounds(10, 11, 271, 14);
		getContentPane().add(lblCaption);
		
		progressBar = new JProgressBar();
		progressBar.setBounds(10, 30, 292, 16);
		getContentPane().add(progressBar);
		
		lblProcessed = new JLabel("Processed 0/0");
		lblProcessed.setBounds(10, 52, 270, 14);
		getContentPane().add(lblProcessed);
		
		JButton btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
	            m_Cancelled = true;
			}
		});
		btnCancel.setBounds(113, 77, 91, 23);
		getContentPane().add(btnCancel);

	}

	public boolean update(long total, long current) {
        lblProcessed.setText("Operation progress: " + current + " / " + total);
        if (total > 0)
        {
            progressBar.setValue((int)Math.round((double)current * 100.0 / (double)total));
        }
        else
        {
            progressBar.setValue(0);
        }
       
        return m_Cancelled;
	}

	public void Prepare(String cap) {
        lblCaption.setText(cap);
        m_Cancelled = false;
        lblProcessed.setText("");
        progressBar.setValue(0);
	}
}
