

import java.awt.Component;
import java.awt.EventQueue;

import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.SwingConstants;
import javax.swing.JTextField;
import javax.swing.JRadioButton;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.border.EtchedBorder;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JList;
import javax.swing.border.LineBorder;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.*;
import SecureBlackbox.PGP.*;
import SecureBlackbox.PGPMIME.*;
import SecureBlackbox.SMIME.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Date;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.io.File;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField txtSubject;
	private JTextField txtFrom;
	private JTextField txtTo;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JTextField tbPubKeyring;
	private JTextField tbSecKeyring;
	private JTextField tbSenderCert;
	private JTextField tbRecipientCert;
	private JRadioButton rbDoNotUseSecurity;
	private JRadioButton rbUseSMIME;
	private JRadioButton rbUsePGPMIME;
	private JCheckBox chkSign;
	private JCheckBox chkSignClearFormat;
	private JCheckBox chkSignRootHeader;
	private JCheckBox chkEncode;
	private JLabel lblEncodeOptions;
	private JLabel lblSignOptions;
	private JPanel gbPGPMIME;
	private JPanel gbSMIME;
	private JButton btnLoadPubKeyring;
	private JButton btnLoadSecKeyring;
	private JButton cmdLoadCertificate;
	private JButton btnLoadRecipientCert;
	private JCheckBox chkPartPlainText;
	private JTextArea txtPartPlainText;
	private JTextArea txtPartHtml;
	private JCheckBox chkPartHtml;
	private JCheckBox checkBox_part_attachments;
	private JList<String> lstAttachments;
	private JCheckBox checkBox_attach_as_uue;
	private TElPGPKeyring SigningKeys;
	private TElPGPKeyring EncryptingKeys;
	private TElCustomCertStorage SenderCertStorage;
	private TElCustomCertStorage RecipientCertStorage;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("MimeMaker");
		setBounds(100, 100, 561, 461);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmAssembleAndSave = new JMenuItem("Assemble and Save");
		mntmAssembleAndSave.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				try {
					assembleSaveClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		mnFile.add(mntmAssembleAndSave);
		
		JSeparator separator = new JSeparator();
		mnFile.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				exitClick();
			}
		});
		mnFile.add(mntmExit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				aboutClick();
			}
		});
		mnHelp.add(mntmAbout);
		
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		getContentPane().add(tabbedPane, BorderLayout.CENTER);
		
		JPanel panel = new JPanel();
		tabbedPane.addTab("Assemble Options", null, panel, null);
		panel.setLayout(null);
		
		JLabel lblSubject = new JLabel("Subject:");
		lblSubject.setBackground(new Color(0, 0, 0));
		lblSubject.setHorizontalAlignment(SwingConstants.CENTER);
		lblSubject.setBounds(10, 11, 63, 14);
		panel.add(lblSubject);
		
		JLabel lblFrom = new JLabel("From:");
		lblFrom.setHorizontalAlignment(SwingConstants.CENTER);
		lblFrom.setBackground(new Color(0, 0, 0));
		lblFrom.setBounds(10, 35, 63, 14);
		panel.add(lblFrom);
		
		JLabel lblTo = new JLabel("To:");
		lblTo.setBackground(new Color(0, 0, 0));
		lblTo.setHorizontalAlignment(SwingConstants.CENTER);
		lblTo.setBounds(10, 58, 63, 14);
		panel.add(lblTo);
		
		txtSubject = new JTextField();
		txtSubject.setText("EldoS MimeBlackbox Example.");
		txtSubject.setBounds(83, 8, 455, 20);
		panel.add(txtSubject);
		txtSubject.setColumns(10);
		
		txtFrom = new JTextField();
		txtFrom.setText("demos@eldos.org");
		txtFrom.setColumns(10);
		txtFrom.setBounds(83, 32, 455, 20);
		panel.add(txtFrom);
		
		txtTo = new JTextField();
		txtTo.setText("demos@localhost");
		txtTo.setColumns(10);
		txtTo.setBounds(83, 55, 455, 20);
		panel.add(txtTo);
		
		JPanel panel_4 = new JPanel();
		panel_4.setBorder(new TitledBorder(null, "Security settings", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_4.setBounds(0, 99, 277, 285);
		panel.add(panel_4);
		panel_4.setLayout(null);
		
		rbDoNotUseSecurity = new JRadioButton("<html><body>Do not use security features for this<br>message</body></html>");
		rbDoNotUseSecurity.setSelected(true);
		buttonGroup.add(rbDoNotUseSecurity);
		rbDoNotUseSecurity.setHorizontalAlignment(SwingConstants.LEFT);
		rbDoNotUseSecurity.setBounds(6, 27, 263, 31);
		panel_4.add(rbDoNotUseSecurity);
		
		rbUseSMIME = new JRadioButton("Use S/MIME security features");
		buttonGroup.add(rbUseSMIME);
		rbUseSMIME.setBounds(6, 63, 202, 23);
		panel_4.add(rbUseSMIME);
		
		rbUsePGPMIME = new JRadioButton("Use PGP/MIME security features");
		buttonGroup.add(rbUsePGPMIME);
		rbUsePGPMIME.setBounds(6, 88, 224, 23);
		panel_4.add(rbUsePGPMIME);
		
		lblSignOptions = new JLabel("Sign options:");
		lblSignOptions.setBounds(16, 118, 148, 14);
		panel_4.add(lblSignOptions);
		
		chkSign = new JCheckBox("Sign Message");
		chkSign.setBounds(25, 139, 113, 23);
		panel_4.add(chkSign);
		
		chkSignClearFormat = new JCheckBox("Sign Clear Format");
		chkSignClearFormat.setBounds(141, 139, 128, 23);
		panel_4.add(chkSignClearFormat);
		
		chkSignRootHeader = new JCheckBox("Sign Root Header");
		chkSignRootHeader.setBounds(25, 165, 139, 23);
		panel_4.add(chkSignRootHeader);
		
		lblEncodeOptions = new JLabel("Encryption options:");
		lblEncodeOptions.setBounds(16, 195, 128, 14);
		panel_4.add(lblEncodeOptions);
		
		chkEncode = new JCheckBox("Encrypt Message");
		chkEncode.setBounds(26, 216, 148, 23);
		panel_4.add(chkEncode);
		
		gbPGPMIME = new JPanel();
		gbPGPMIME.setBorder(new TitledBorder(null, "PGP/MIME Options", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		gbPGPMIME.setBounds(279, 99, 269, 142);
		panel.add(gbPGPMIME);
		gbPGPMIME.setLayout(null);
		
		JLabel lblPublicKeyringFile = new JLabel("Public keyring file:");
		lblPublicKeyringFile.setBounds(10, 23, 200, 14);
		gbPGPMIME.add(lblPublicKeyringFile);
		
		JLabel lblSecretKeyringFile = new JLabel("Secret keyring file:");
		lblSecretKeyringFile.setBounds(10, 71, 200, 14);
		gbPGPMIME.add(lblSecretKeyringFile);
		
		tbPubKeyring = new JTextField();
		tbPubKeyring.setBounds(10, 40, 214, 20);
		gbPGPMIME.add(tbPubKeyring);
		tbPubKeyring.setColumns(10);
		
		btnLoadPubKeyring = new JButton(".");
		btnLoadPubKeyring.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadPubKeyringClick();
			}
		});
		btnLoadPubKeyring.setBounds(234, 37, 25, 23);
		gbPGPMIME.add(btnLoadPubKeyring);
		
		btnLoadSecKeyring = new JButton(".");
		btnLoadSecKeyring.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadSecKeyringClick();
			}
		});
		btnLoadSecKeyring.setBounds(234, 87, 25, 23);
		gbPGPMIME.add(btnLoadSecKeyring);
		
		tbSecKeyring = new JTextField();
		tbSecKeyring.setColumns(10);
		tbSecKeyring.setBounds(10, 90, 214, 20);
		gbPGPMIME.add(tbSecKeyring);
		
		gbSMIME = new JPanel();
		gbSMIME.setLayout(null);
		gbSMIME.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "S/MIME Options", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		gbSMIME.setBounds(279, 242, 269, 142);
		panel.add(gbSMIME);
		
		JLabel lblSenderCertificate = new JLabel("Sender certificate:");
		lblSenderCertificate.setBounds(10, 23, 200, 14);
		gbSMIME.add(lblSenderCertificate);
		
		JLabel lblRecipientsCertificate = new JLabel("Recipients certificate:");
		lblRecipientsCertificate.setBounds(10, 71, 200, 14);
		gbSMIME.add(lblRecipientsCertificate);
		
		tbSenderCert = new JTextField();
		tbSenderCert.setColumns(10);
		tbSenderCert.setBounds(10, 40, 214, 20);
		gbSMIME.add(tbSenderCert);
		
		cmdLoadCertificate = new JButton(".");
		cmdLoadCertificate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					loadCertClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		cmdLoadCertificate.setBounds(234, 37, 25, 23);
		gbSMIME.add(cmdLoadCertificate);
		
		btnLoadRecipientCert = new JButton(".");
		btnLoadRecipientCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					loadRecipClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});		
		btnLoadRecipientCert.setBounds(234, 87, 25, 23);
		gbSMIME.add(btnLoadRecipientCert);
		
		tbRecipientCert = new JTextField();
		tbRecipientCert.setColumns(10);
		tbRecipientCert.setBounds(10, 90, 214, 20);
		gbSMIME.add(tbRecipientCert);
		
		JPanel panel_1 = new JPanel();
		tabbedPane.addTab("Text Part", null, panel_1, null);
		panel_1.setLayout(null);
		
		chkPartPlainText = new JCheckBox("Use this part");
		chkPartPlainText.setSelected(true);
		chkPartPlainText.setBounds(6, 7, 124, 23);
		panel_1.add(chkPartPlainText);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(6, 37, 532, 314);
		panel_1.add(scrollPane);
		
		txtPartPlainText = new JTextArea();
		txtPartPlainText.setText("Plaint text part.");
		scrollPane.setViewportView(txtPartPlainText);
		
		JPanel panel_2 = new JPanel();
		tabbedPane.addTab("HTML Part", null, panel_2, null);
		panel_2.setLayout(null);
		
		chkPartHtml = new JCheckBox("Use this part");
		chkPartHtml.setBounds(6, 7, 124, 23);
		panel_2.add(chkPartHtml);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(6, 37, 532, 314);
		panel_2.add(scrollPane_1);
		
		txtPartHtml = new JTextArea();
		txtPartHtml.setText("<HTML>\r\n  <BR>Html code part.<BR>\r\n  <HR>\r\n</HTML>");
		scrollPane_1.setViewportView(txtPartHtml);
		
		JPanel panel_3 = new JPanel();
		tabbedPane.addTab("Attachments", null, panel_3, null);
		panel_3.setLayout(null);
		
		checkBox_part_attachments = new JCheckBox("Attach files");
		checkBox_part_attachments.setBounds(6, 7, 97, 23);
		panel_3.add(checkBox_part_attachments);
		
		lstAttachments = new JList<String>(new DefaultListModel<String>());
		lstAttachments.setBorder(new LineBorder(new Color(0, 0, 0)));
		lstAttachments.setBounds(6, 38, 329, 186);
		panel_3.add(lstAttachments);
		
		JButton btnAddAttachment = new JButton("Add Attachment");
		btnAddAttachment.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addAttachClick();
			}
		});
		btnAddAttachment.setBounds(374, 35, 153, 23);
		panel_3.add(btnAddAttachment);
		
		JButton btnRemoveAttachment = new JButton("Remove Attachment");
		btnRemoveAttachment.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeAttachClick();
			}
		});		
		btnRemoveAttachment.setBounds(374, 64, 153, 23);
		panel_3.add(btnRemoveAttachment);
		
		checkBox_attach_as_uue = new JCheckBox("Attach as UUE");
		checkBox_attach_as_uue.setBounds(374, 94, 121, 23);
		panel_3.add(checkBox_attach_as_uue);
		
		JLabel lblNewLabel = new JLabel("<html><body><center>- Warning: Not recomended make multipart message with UUE attachments.</center></body></html>");
		lblNewLabel.setBounds(374, 124, 164, 71);
		panel_3.add(lblNewLabel);

		init();
		initRb();
	}

	private void initRb() {
		rbDoNotUseSecurity.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rbDoNotUseSecurity.isSelected()) {
					enablePanel(gbPGPMIME, false);
					enablePanel(gbSMIME, false);
					chkSign.setEnabled(false);
					chkSignRootHeader.setEnabled(false);
					chkSignClearFormat.setEnabled(false);
					chkEncode.setEnabled(false);
					lblEncodeOptions.setEnabled(false);
					lblSignOptions.setEnabled(false);
				}
			}
		});		
		rbUseSMIME.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rbUseSMIME.isSelected()) {
					enablePanel(gbPGPMIME, false);
					enablePanel(gbSMIME, true);
					chkSign.setEnabled(true);
					chkSignRootHeader.setEnabled(true);
					chkSignClearFormat.setEnabled(true);
					chkEncode.setEnabled(true);
					lblEncodeOptions.setEnabled(true);
					lblSignOptions.setEnabled(true);
				}				
			}
		});		
		rbUsePGPMIME.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rbUsePGPMIME.isSelected()) {
					enablePanel(gbPGPMIME, true);
					enablePanel(gbSMIME, false);
					chkSign.setEnabled(true);
					chkSignRootHeader.setEnabled(true);
					chkSignClearFormat.setEnabled(true);
					chkEncode.setEnabled(true);
					lblEncodeOptions.setEnabled(true);
					lblSignOptions.setEnabled(true);
				}				
			}
		});
	}

	void enablePanel(JPanel p, boolean val) {
		p.setEnabled(val);
		Component[] com = p.getComponents();  
		for (int a = 0; a < com.length; a++) {  
		     com[a].setEnabled(val);  
		}  		
	}
	
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		SBMIME.initialize();
        SBSMIMECore.initialize();
        SBPGPMIME.initialize();	
		
        txtSubject.setText(SBMIME.cXMailerDefaultFieldValue);
        		
		enablePanel(gbPGPMIME, false);
		enablePanel(gbSMIME, false);
		chkSign.setEnabled(false);
		chkSignRootHeader.setEnabled(false);
		chkSignClearFormat.setEnabled(false);
		chkEncode.setEnabled(false);
		lblEncodeOptions.setEnabled(false);
		lblSignOptions.setEnabled(false);
		SigningKeys = new TElPGPKeyring();
		EncryptingKeys = new TElPGPKeyring();
	}

	protected void aboutClick() {
		AboutDialog dlg = new AboutDialog();
		dlg.setVisible(true);
	}

	protected void exitClick() {
		dispose();
	}

	protected void assembleSaveClick() throws Exception, ElMimeException {
		int iPartCount = 0;
		if (chkPartPlainText.isSelected()) {
			iPartCount += 1;
		}
		if (chkPartHtml.isSelected()) {
			iPartCount += 1;
		}
		if (checkBox_part_attachments.isSelected() && lstAttachments.getModel().getSize() > 0) {
			iPartCount += 1;
		}
		if (iPartCount == 0) {
			//return;
			throw new Exception("Warning: Please define any mime part !");
		}
		
		String saveFileName = getSaveFileName();
		if (saveFileName.length() == 0) {
			return;
		}
		TElMessage msg = null;
		TElPlainTextPart mpt = null;
		TElMultiPartList mmp = null;
		TElMultiPartList ammp = null;
		TElMultiPartList par = null;
		TElMessagePart mpc = null;


		try {
			if (iPartCount == 1) {
				// Make one part message
				msg = new TElMessage("");
				// SBMIME.Unit.cXMailerDefaultFieldValue)
				if (chkPartPlainText.isSelected()) {
					mpt = new TElPlainTextPart(msg, mmp);
					msg.setMainPart(mpt, false);
					mpt.setText(txtPartPlainText.getText());
				} else if (chkPartHtml.isSelected()) {
					mpt = new TElPlainTextPart(msg, mmp);
					msg.setMainPart(mpt, false);
					mpt.setContentSubtype("html", true);
					mpt.setText(txtPartHtml.getText());
				} else if (checkBox_part_attachments.isSelected() && lstAttachments.getModel().getSize() > 0) {
					//
					//					 * if ( checkBox_attach_as_uue.Checked ) {
					//                      mpt = new TElPlainTextPart(msg, mmp);
					//                      msg.setMainPart(mpt, false);
					//                      TElMessagePartHandlerUUE uue = new TElMessagePartHandlerUUE(null);
					//                      mpt.MessageBodyPartHandler = uue;
					//                      for ( int i = 0; i < lstAttachments.Items.Count; i++ )
					//                        uue.addAttachedFile(  (string) lstAttachments.Items[i] );
					//                    } else 
					//					
					if ((true)) {
						int i = 0;
						for (i = 0; i <= lstAttachments.getModel().getSize() - 1; i++) {
							msg.attachFile("", lstAttachments.getModel().getElementAt(i));
							// == application/octet-stream'
						}
					}
				}
			// Make multiparts message
			} else {
				msg = new TElMessage(false, SBMIME.cXMailerDefaultFieldValue);
				//== do not create default main part
				mmp = new TElMultiPartList(msg, null);
				msg.setMainPart(mmp, false);

				par = mmp;
				if (chkPartPlainText.isSelected() && chkPartHtml.isSelected()) {
					if (checkBox_part_attachments.isSelected() && lstAttachments.getModel().getSize() > 0) {
						ammp = new TElMultiPartList(msg, mmp);
						mmp.addPart(ammp);
						par = ammp;
						ammp.setContentType("multipart", true);
						ammp.setContentSubtype("alternative", false);
						mmp.setContentType("multipart", true);
						mmp.setContentSubtype("mixed", false);
					} else {
						mmp.setContentType("multipart", true);
						mmp.setContentSubtype("alternative", false);
					}
				}

				if (chkPartPlainText.isSelected()) {
					mpt = new TElPlainTextPart(msg, par);
					par.addPart(mpt);
					mpt.setText(txtPartPlainText.getText());
				}
				if (chkPartHtml.isSelected()) {
					mpt = new TElPlainTextPart(msg, par);
					par.addPart(mpt);
					mpt.setContentSubtype("html", true);
					mpt.setText(txtPartHtml.getText());
				}
				if (checkBox_part_attachments.isSelected() && lstAttachments.getModel().getSize() > 0) {
					//
					//                    // You can make uue attachment when SBMIMEUUE.bSimpleMode == False,
					//                    // but many mail client application do not read this message.
					//                    // Example: Outlook Express.
					//
					//                    // ShowMessage('WARNING: not recomend make multipart message with uue attachments');
					//
					//                    if ( checkBox_attach_as_uue.Checked )
					//                    {
					//                      SBMIMEUUE.Unit.bSimpleMode := false;
					//
					//                      mpt = new TElPlainTextPart(msg, mmp);
					//                      mmp.addPart(mpt);
					//                      TElMessagePartHandlerUUE uue = new TElMessagePartHandlerUUE(null);
					//                      mpt.MessageBodyPartHandler = uue;
					//                      for ( int i = 0; i < lstAttachments.Items.Count; i++ )
					//                        uue.addAttachedFile(  (string) lstAttachments.Items[i] );
					//                    }
					//                    else
					//                    
					if ((true)) {
						int i = 0;
						for (i = 0; i <= lstAttachments.getModel().getSize() - 1; i++) {
							String fileName = lstAttachments.getModel().getElementAt(i);
							// 1)
							// msg.attachFile(""/* == application/octet-stream'*/, fileName );
							// or alternative (manual):
							// 2)
							mpc = new TElMessagePart(msg, mmp);
							mmp.addPart(mpc);

							String s = new File(fileName).getName();
							TElMessageHeaderField headerField = mpc.getHeader().addField("Content-Type", "application/octet-stream", true);
							headerField.addParam("name", s);
							headerField = mpc.getHeader().addField("Content-Disposition", "attachment", true);
							headerField.addParam("filename", s);
							mpc.getHeader().addField("Content-Transfer-Encoding", "base64", true);
							TElFileStream file_data = new TElFileStream(fileName, "rw", true);
							mpc.setData(file_data, (int)file_data.getLength(), false);
							// stream controled in mpc
							file_data = null;
						}
					}
				}
			}
			msg.getFrom().addAddress("From e-mail: " + txtFrom.getText(), txtFrom.getText());
			msg.getTo_().addAddress("To e-mail: " + txtTo.getText(), txtTo.getText());
			msg.setSubject(txtSubject.getText());
			msg.setDate(new Date());
			msg.setMessageID(TElMessage.generateMessageID());


			if (rbUseSMIME.isSelected()) {
				if (chkSign.isSelected() || chkEncode.isSelected()) {
					TElMessagePartHandlerSMime smime = new TElMessagePartHandlerSMime(null);
					msg.getMainPart().setMessagePartHandler(smime);
					if (chkSign.isSelected()) {
						smime.setEncoderSigned(true);
						smime.setEncoderSignOnlyClearFormat(chkSignClearFormat.isSelected());
						smime.setEncoderSignRootHeader(chkSignRootHeader.isSelected());
						// - allow sign some fields in header (subject,... ) except (From, To, Sender, Reply-To)
						smime.setEncoderMicalg("sha1");
					}
					if (chkEncode.isSelected()) {
						smime.setEncoderCrypted(true);
						smime.setEncoderCryptBitsInKey(128);
						smime.setEncoderCryptAlgorithm(SBConstants.SB_ALGORITHM_CNT_3DES);
					}
					smime.setEncoderCryptCertStorage(RecipientCertStorage);
					smime.setEncoderSignCertStorage(SenderCertStorage);
				}

			}

			if (rbUsePGPMIME.isSelected()) {
				if (chkSign.isSelected() || chkEncode.isSelected()) {
					TElMessagePartHandlerPGPMime pgpmime = new TElMessagePartHandlerPGPMime(null);
					msg.getMainPart().setMessagePartHandler(pgpmime);
					if (chkSign.isSelected()) {
						pgpmime.setSign(true);
					}
					if (chkEncode.isSelected()) {
						pgpmime.setEncrypt(true);
					}
					pgpmime.setEncryptingKeys(EncryptingKeys);
					pgpmime.setSigningKeys(SigningKeys);
					pgpmime.setOnKeyPassphrase(new TSBPGPKeyPassphraseEvent(OnKeyPassphrase));
				}
			}

			TElFileStream sm = new TElFileStream(saveFileName, "rw", true);

			int res = msg.assembleMessage(sm, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", false);
			// Charset of message:
			// HeaderEncoding
			//  variants:  he8bit  | heQuotedPrintable  | heBase64
			// BodyEncoding
			//  variants:   '8bit' | 'quoted-printable' |  'base64'
			// AttachEncoding
			//  variants:   '8bit' | 'quoted-printable' |  'base64'

			sm.Free();
			if (res != SBMIME.EL_OK & res != SBMIME.EL_WARNING) {
				throw new ElMimeException("ERROR: Assembling message return error code: " + res + "\"");
			}
		//of: try
		} finally {
			if ((msg != null)) {
				msg.Free();
			}
		}
	}
	
	TSBPGPKeyPassphraseEvent.Callback OnKeyPassphrase = new TSBPGPKeyPassphraseEvent.Callback() {
		public void tsbpgpKeyPassphraseEventCallback(TObject sender,
				TElPGPCustomSecretKey key, TSBString pass, TSBBoolean cancel) {
			String p = requestKeyPassphrase(key);
			if (p.length() == 0) {
				cancel.value = true;
			} else {
			pass.value = p;
			cancel.value = false;
			}
		}
	};

	private String requestKeyPassphrase(TElPGPCustomSecretKey key) {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password for key " + SBPGPUtils.keyID2Str(key.keyID(), true), JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}
	
	private String getSaveFileName() {
		JFileChooser fc = new JFileChooser();
		
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected String getOpenCertFile() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( BIN | DER | PFX | PKCS#7 )-encoded certificate", "bin", "cer", "pfx", "p7b");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected String getOpenFile() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select file");
		
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private boolean addToStorageCertificateFromFile(TElCustomCertStorage storage, String fileName, String password) {
		TElX509Certificate cert = new TElX509Certificate();
		try {
			cert.loadFromFileAuto(fileName, password);
			storage.add(cert, true);
			return true;
		} catch (Exception e) {
			return false;
		}
	}
	
	protected void loadRecipClick() throws Exception {
		String fileName = getOpenCertFile();
		if (fileName.length() > 0) {
			RecipientCertStorage.clear();
			String pass = requestPassphrase();

			Boolean bOK = addToStorageCertificateFromFile(RecipientCertStorage, fileName, pass);
			// Global SMIME Storage
			// file certificate:
			// certificate password:
			if (bOK) {
				TElX509Certificate cer = (TElX509Certificate)RecipientCertStorage.getCertificate(RecipientCertStorage.getCount() - 1);
				TElByteArrayList arList = new TElByteArrayList();
				cer.getSubjectRDN().getValuesByOID(SBConstants.SB_CERT_OID_EMAIL.Data, arList);
				bOK = arList.getCount() > 0;
				if (bOK) {
					// Convert UTF8 to unicode string:
					String wsFrom = new String(arList.getItem(0));
					bOK = wsFrom.length() > 0;
					if (bOK) {
						txtTo.setText(wsFrom);
						tbRecipientCert.setText(fileName);
					}
				}
			}
			if (!bOK) {
				throw new Exception("Cannot load certificate or certificate is bad");
			}
		}
	}

	private String requestPassphrase() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password:", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}
	
	protected void loadCertClick() throws Exception {
		String fileName = getOpenCertFile();
		SenderCertStorage.clear();
		String pass = requestPassphrase();

		Boolean bOK = addToStorageCertificateFromFile(SenderCertStorage, fileName, pass);
		// Global SMIME Storage
		// file certificate:
		// certificate password:
		if (bOK) {
			TElX509Certificate cer = (TElX509Certificate)SenderCertStorage.getCertificate(SenderCertStorage.getCount() - 1);
			TElByteArrayList arList = new TElByteArrayList();
			cer.getSubjectRDN().getValuesByOID(SBConstants.SB_CERT_OID_EMAIL.Data, arList);
			bOK = arList.getCount() > 0;
			if (bOK) {
				// Convert UTF8 to unicode string:
				String wsFrom = new String(arList.getItem(0));
				bOK = wsFrom.length() > 0;
				if (bOK) {
					txtFrom.setText(wsFrom);
					tbSenderCert.setText(fileName);
				}
			}
		}
		if (!bOK) {
			throw new Exception("Cannot load certificate or certificate is bad");
		}		
	}

	protected void loadSecKeyringClick() {
		String fileName = getOpenFile();
		
		if (fileName.length() > 0 ){
			try {
				SigningKeys.load(fileName, "", true);
			} catch (Exception ex) {
				showMessage("Unable to load keyring: " + ex.getMessage());
				return;
			}
			if (SigningKeys.getSecretCount() < 1) {
				showMessage("No secret keys found");
			} else {
				if (SigningKeys.getSecretKeys(0).getPublicKey().getUserIDCount() > 0) {
					txtFrom.setText(SigningKeys.getSecretKeys(0).getPublicKey().getUserID(0).getName());
				}
				tbSecKeyring.setText(fileName);
			}			
		}
	}

	protected void loadPubKeyringClick() {
		String fileName = getOpenFile();
		if (fileName.length() > 0) {
			try {
				EncryptingKeys.load("", fileName, true);
			} catch (Exception ex) {
				showMessage("Unable to load keyring: " + ex.getMessage());
				return;
			}
			if (EncryptingKeys.getPublicCount() < 1) {
				showMessage("No public keys found");
			} else {
				if (EncryptingKeys.getPublicKeys(0).getUserIDCount() > 0) {
					txtTo.setText(EncryptingKeys.getPublicKeys(0).getUserID(0).getName());
				}
				tbPubKeyring.setText(fileName);
			}
		}		
	}

	private void showMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	protected void removeAttachClick() {
		DefaultListModel<String> model = (DefaultListModel<String>)lstAttachments.getModel();
		model.remove(lstAttachments.getSelectedIndex());
	}

	protected void addAttachClick() {
		String fileName = getOpenFile();
		
		if (fileName.length() > 0)
			((DefaultListModel<String>)lstAttachments.getModel()).addElement(fileName);
	}
}
