

import java.awt.EventQueue;

//import javax.swing.DefaultComboBoxModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import org.freepascal.rtl.AnsistringClass;
import org.freepascal.rtl.TObject;


import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.SBMIME;
import SecureBlackbox.MIME.TElMessageHeader;
import SecureBlackbox.MIME.TElMessageHeaderField;
import SecureBlackbox.Mail.*;
import SecureBlackbox.SSLCommon.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.net.URL;

public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTable table;
	private TElIMAPClient client;
	private JComboBox<String> cbMailBoxes;
	private TElIMAPMailBoxState mailBoxState;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("EldoS IMAP client demo");
		setBounds(100, 100, 483, 319);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmConnect = new JMenuItem("Connect");
		mntmConnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				try {
					
					Connect();
					
				} catch (EElIMAPError ex) {
					showErrorMessage(ex.getMessage() + " [ErrorCode = " + ex.getErrorCode() + "]", "Error");
					client.close(true);
				}
			}
		});
		mnFile.add(mntmConnect);
		
		JMenuItem mntmDisconnect = new JMenuItem("Disconnect");
		mntmDisconnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Disconnect();
			}
		});
		mnFile.add(mntmDisconnect);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				dispose();
				System.exit(0);
			}
		});
		mnFile.add(mntmExit);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		getContentPane().add(toolBar, BorderLayout.NORTH);
		
		JButton btnConnect = new JButton("");
		btnConnect.setIcon(getIcon("connect"));
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					
					Connect();
					
				} catch (EElIMAPError ex) {
					showErrorMessage(ex.getMessage() + " [ErrorCode = " + ex.getErrorCode() + "]", "Error");
					client.close(true);
				}
			}
		});
		toolBar.add(btnConnect);
		
		JButton btnDisconnect = new JButton("");
		btnDisconnect.setIcon(getIcon("disc"));
		btnDisconnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Disconnect();
			}
		});
		toolBar.add(btnDisconnect);
		
		JButton btnDownload = new JButton("");
		btnDownload.setIcon(getIcon("down"));
		btnDownload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					Download();
				} catch (EElIMAPError ex) {
					showErrorMessage(ex.getMessage() + " [ErrorCode = " + ex.getErrorCode() + "]", "Error");
				}
			}
		});
		toolBar.add(btnDownload);
		
		JButton btnDelete = new JButton("");
		btnDelete.setIcon(getIcon("close"));
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					Delete();
				} catch (EElIMAPError ex) {
					ex.printStackTrace();
					showErrorMessage(ex.getMessage() + " [ErrorCode = " + ex.getErrorCode() + "]", "Error");
				}
			}
		});
		toolBar.add(btnDelete);
		
		cbMailBoxes = new JComboBox<String>();
		cbMailBoxes.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {				
				client.selectBox(cbMailBoxes.getSelectedItem().toString());
				mailBoxState.copyFrom(client.getMailBoxState());
				GetMessageList(false);
			}
		});
		toolBar.add(cbMailBoxes);
		
		
		JScrollPane scrollPane = new JScrollPane();
		getContentPane().add(scrollPane, BorderLayout.CENTER);
		
		table = new JTable(new ConTableModel());
		table.setFillsViewportHeight(true);
		scrollPane.setViewportView(table);

		init();
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}
	
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		client = new TElIMAPClient();
		client.setOnCertificateValidate(new TSBCertificateValidateEvent(client_OnCertificateValidate));
		
		mailBoxState = new TElIMAPMailBoxState();
	}

	TSBCertificateValidateEvent.Callback client_OnCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender,
				TElX509Certificate cert, TSBBoolean accept) {
			accept.value = true;
		}
	};
	
	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);		
	}
	
	
	private void Connect() throws EElIMAPError
	{
		if (client.getActive())
		{
			showErrorMessage("You are already connected! Please disconnect first.", "Error");
			return;
		}

		ConnectDialog Frm = new ConnectDialog();
		Frm.setModal(true);
		Frm.setVisible(true);
		
		if (Frm.isOK())
		{
			client.setAddress(Frm.getServer());
			client.setPort(Frm.getPort());
			client.setUseSSL(Frm.getUseSSL());						

			switch (Frm.getSSLMode())
			{
				case 0: 
					client.setSSLMode(TSBSSLMode.smExplicit);
					break;
				case 1:
					client.setSSLMode(TSBSSLMode.smImplicit);
					break;
			}

			try
			{
				client.open();
				client.setUsername(Frm.getUsername());
				client.setPassword(Frm.getPassword());
				client.login();
				
				cbMailBoxes.removeAllItems();
				TElIMAPMailBoxesList list = new TElIMAPMailBoxesList();
				client.list("", "*", list);
				if (list.getCount() == 0) 
					client.list("/", "*", list);
				for(int i = 0; i < list.getCount(); i++)
				{
					TElIMAPMailBoxInfo box = list.get(i);
					if ((box.getAttributes() & SBIMAPClient.imapNoSelect) == 0)
						cbMailBoxes.addItem(box.getName());
					
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
				showErrorMessage(e.getMessage(), "Error");
				client.close(true);
			}
		}
	}
	
	private boolean chooseMessage(String msg) {
		return (JOptionPane.showConfirmDialog(this, msg) == JOptionPane.YES_OPTION);
	}


	private void Disconnect()
	{
		if (client.getActive())
			client.close(false);
	}

	private void Download() throws EElIMAPError
	{
		String fileName = getSaveFileName();
		if ((table.getSelectedRows().length == 1) && (fileName.length() > 0))
		{
			TElFileStream FS = new TElFileStream(fileName, "rw", true);
			try
			{
				int ID = ((ConTableModel)table.getModel()).getTag(table.getSelectedRow());
				client.fetchMessage(ID, true, FS);
			}
			finally
			{
				FS.Free();
			}
		}
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private void Delete() throws EElIMAPError
	{
		int[] indexes = table.getSelectedRows();
		for (int i = 0; i < indexes.length; i++)
		{
			int ID = ((ConTableModel)table.getModel()).getTag(indexes[i]);
		    client.store(ID, ID, true, TSBIMAPStoreFlagsOperation.imapAddFlags, SBIMAPClient.imapDeletedFlag, true, null);
		}
	    client.expunge(null);
		GetMessageList(false);
	}
	
	private void GetMessageList(boolean onlyNew)
	{
		ConTableModel model = ((ConTableModel)table.getModel());
		if (!onlyNew)
			model.clear();
		
	    if (client.getMailBoxState().getTotalMessages() > 0)
	    {
	    	int b;
			String[] charset = {"utf-8"};
			TElMessageHeader header = new TElMessageHeader();
	    	
	        if (onlyNew)
	        	b = client.getMailBoxState().getTotalMessages();
	        else
	        	b = 1;
	        TElIMAPFetchResponse response = client.fetch(b, SBIMAPClient.imapLastMessage, false,
	        	"UID RFC822.SIZE INTERNALDATE FLAGS BODY[HEADER.FIELDS (FROM SUBJECT)]");
			for (int i = 0; i < response.getCount(); i++)
			{
				TElIMAPFetchResponseLine line = response.get(i);
				
				AnsistringClass headerValue = new AnsistringClass(line.getByName("BODY[HEADER.FIELDS (FROM SUBJECT)]").getRawValue() + "\r\n\r\n"); 				
				header.clear();
				header.parse(headerValue, charset, false);				
				
				TElMessageHeaderField field = header.getField("From", 0);
				String f = (field != null) ? field.getValue() : "";
				
				field = header.getField("Subject", 0);
				String s = (field != null) ? field.getValue() : "";
				
				String z = line.getByName("RFC822.SIZE").getNumber() + "";				
				int tag = (int)line.getByName("UID").getNumber();				
				
				model.addRow(f, s, z, tag);
			}			
	    }
	}	
}
