import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JCheckBox;
import javax.swing.JPasswordField;

import SecureBlackbox.Office.TElOfficeBinaryRC4CryptoAPIEncryptionHandler;
import SecureBlackbox.Office.TElOfficeBinaryRC4EncryptionHandler;
import SecureBlackbox.Office.TElOfficeCustomEncryptionHandler;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;


public class BinEncOptionsForm extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbDest;
	private JPasswordField tbPassword;
	private JComboBox<String> cmbEncryptionType;
	private JSpinner tbKeyLength;
	private JCheckBox cbEncryptDocProps;
	private boolean isOk;

	TElOfficeBinaryRC4EncryptionHandler _RC4EncryptionHandler;
	TElOfficeBinaryRC4CryptoAPIEncryptionHandler _RC4CryptoAPIEncryptionHandler;
	private JButton btnEncrypt;
	private FileNameExtensionFilter mFilter;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			BinEncOptionsForm dialog = new BinEncOptionsForm();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public BinEncOptionsForm() {
		setTitle("Encryption options");
		setBounds(100, 100, 358, 296);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBounds(10, 11, 329, 62);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JLabel lblDestinationFile = new JLabel("Destination file");
				lblDestinationFile.setBounds(10, 11, 172, 14);
				panel.add(lblDestinationFile);
			}
			{
				tbDest = new JTextField();
				tbDest.setBounds(10, 31, 208, 20);
				panel.add(tbDest);
				tbDest.setColumns(10);
			}
			
			JButton btnBrowse = new JButton("Browse");
			btnBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					browseClick();
				}
			});
			btnBrowse.setBounds(228, 30, 91, 23);
			panel.add(btnBrowse);
		}
		{
			JPanel panel = new JPanel();
			panel.setBounds(10, 84, 329, 141);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JLabel lblEncryptionType = new JLabel("Encryption type");
				lblEncryptionType.setBounds(10, 11, 119, 14);
				panel.add(lblEncryptionType);
			}
			{
				cmbEncryptionType = new JComboBox<String>();
				cmbEncryptionType.addItemListener(new ItemListener() {
					public void itemStateChanged(ItemEvent e) {
						cmbEncryptionType_SelectedIndexChanged(e);
					}
				});
				cmbEncryptionType.setModel(new DefaultComboBoxModel<String>(new String[] {"RC4/40 bits", "RC4 CryptoAPI"}));
				cmbEncryptionType.setBounds(139, 7, 173, 22);
				panel.add(cmbEncryptionType);
			}
			{
				JLabel lblKeyLength = new JLabel("Key length");
				lblKeyLength.setBounds(10, 47, 108, 14);
				panel.add(lblKeyLength);
			}
			
			tbKeyLength = new JSpinner();
			tbKeyLength.setModel(new SpinnerNumberModel(new Integer(128), null, null, new Integer(1)));
			tbKeyLength.setBounds(139, 44, 173, 20);
			panel.add(tbKeyLength);
			
			cbEncryptDocProps = new JCheckBox("Encrypt Document Properties");
			cbEncryptDocProps.setBounds(10, 76, 302, 23);
			panel.add(cbEncryptDocProps);
			
			JLabel lblPassword = new JLabel("Password");
			lblPassword.setBounds(10, 116, 108, 14);
			panel.add(lblPassword);
			
			tbPassword = new JPasswordField();
			tbPassword.setBounds(139, 113, 173, 20);
			panel.add(tbPassword);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnEncrypt = new JButton("Encrypt");
				btnEncrypt.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						encryptClick();
					}
				});
				btnEncrypt.setActionCommand("OK");
				buttonPane.add(btnEncrypt);
				getRootPane().setDefaultButton(btnEncrypt);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelClick();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	protected void cmbEncryptionType_SelectedIndexChanged(ItemEvent e) {
		int i = cmbEncryptionType.getSelectedIndex();
		btnEncrypt.setEnabled(i >= 0);
		tbPassword.setEnabled(i >= 0);
		tbKeyLength.setEnabled(i == 1);
		if (i == 0)
			tbKeyLength.setValue(40);
		else
			tbKeyLength.setValue(128);

		cbEncryptDocProps.setEnabled(i == 1);
		cbEncryptDocProps.setSelected(i == 1);
	}

	protected void browseClick() {
		String fileName = getOpenFileName();
		if (fileName.length() > 0)
			tbDest.setText(fileName);	
	}
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    
		fc.setFileFilter(mFilter);
	    
		int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}	

	private void init() {
		_RC4EncryptionHandler = new TElOfficeBinaryRC4EncryptionHandler();
		_RC4CryptoAPIEncryptionHandler = new TElOfficeBinaryRC4CryptoAPIEncryptionHandler();
	}

	protected void cancelClick() {
		dispose();
	}

	protected void encryptClick() {
		isOk = true;
		setVisible(false);
	}

	public TElOfficeCustomEncryptionHandler getEncryptionHandler() {
		if (cmbEncryptionType.getSelectedIndex() == 0)
		{
			_RC4EncryptionHandler.setPassword(new String(tbPassword.getPassword()));
			return _RC4EncryptionHandler;
		}
		else if (cmbEncryptionType.getSelectedIndex() == 1)
		{
			_RC4CryptoAPIEncryptionHandler.setKeyLength(((SpinnerNumberModel)tbKeyLength.getModel()).getNumber().intValue());
			_RC4CryptoAPIEncryptionHandler.setEncryptDocumentProperties(cbEncryptDocProps.isSelected());
			_RC4CryptoAPIEncryptionHandler.setPassword(new String(tbPassword.getPassword()));
			return _RC4CryptoAPIEncryptionHandler;
		}
		else
			return null;
	}

	public void setSaveDefaultExt(String ext) {
		mFilter = new FileNameExtensionFilter(String.format("Current document type *.%s | All files (*.*)|*.*", ext), ext, "*");	 
	}
	
	public boolean isOK() {
		return isOk;
	}

	public String getDestText() {
		return tbDest.getText();
	}
}
