import java.util.ArrayList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class SignatureHandlerInfoModel extends AbstractTableModel {
	
	private static final long serialVersionUID = 1L;

	private static final String[] columnNames = {
    		"Name",
    		"Value",
    };
	
	private List<SignatureHandlerInfoRow> data = new ArrayList<SignatureHandlerInfoRow>();

	public int getRowCount() {
		return data.size();
	}
	
	public String getColumnName(int column) {
        return columnNames[column];
    }

	public int getColumnCount() {
		return columnNames.length;
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		SignatureHandlerInfoRow row = data.get(rowIndex);
		String res = null;
		
		switch (columnIndex) {
		case 0:
			res = row.getName();
			break;
		case 1:
			res = row.getValue();
			break;
		}
		
		return res;
	}
	
	public void clear() {
		data.clear();
		fireTableDataChanged();
	}
	
	public void add(String name, String value) {
		data.add(new SignatureHandlerInfoRow(name, value));
		fireTableDataChanged();
	}
	
	public void remove(int index) {
		data.remove(index);
		fireTableDataChanged();
	}
}
