import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JRadioButton;
import javax.swing.JSeparator;

import SecureBlackbox.Base.*;
import SecureBlackbox.XML.*;
import SecureBlackbox.XMLSecurity.*;

import javax.swing.DefaultComboBoxModel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTextArea;

public class RefDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edID;
	private JTextField edDigestValue;
	private JTextField edURI;
	private JTable lbTransforms;
	private JTextField edXPath;
	private JTextField edXPathNSMap;
	private JTextField edURINode;
	private JTextField edNSMap;
	private JComboBox<String> cmbDigestMethod;
	private JComboBox<String> cmbTransform;
	private JRadioButton rbURINode;
	private JRadioButton rbURIData;
	protected boolean isOk;
	
    public TElXMLDOMDocument Document;
    private TElXMLDOMNode FURINode;
    private TElXMLReference FReference = null;
	private JTextArea mmData;
	private boolean FVerify = false;
	private JButton btnVerify;
	private JButton btnAdd;
	private JButton btnDelete;
	private JLabel lbXPath;
	private JLabel lbXPathNS;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			RefDialog dialog = new RefDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public RefDialog() {
		setTitle("Reference Options");
		setBounds(100, 100, 450, 688);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		edID = new JTextField();
		edID.setBounds(141, 11, 239, 20);
		contentPanel.add(edID);
		edID.setColumns(10);
		
		edDigestValue = new JTextField();
		edDigestValue.setBounds(141, 74, 239, 20);
		contentPanel.add(edDigestValue);
		edDigestValue.setColumns(10);
		
		edURI = new JTextField();
		edURI.setBounds(141, 105, 239, 20);
		contentPanel.add(edURI);
		edURI.setColumns(10);
		
		cmbDigestMethod = new JComboBox<String>();
		cmbDigestMethod.setModel(new DefaultComboBoxModel<String>(new String[] {"MD5", "SHA1", "SHA 224", "SHA 256", "SHA 384", "SHA 512", "RIPEMD 160"}));
		cmbDigestMethod.setBounds(141, 41, 239, 22);
		contentPanel.add(cmbDigestMethod);
		
		JLabel lblId = new JLabel("ID");
		lblId.setHorizontalAlignment(SwingConstants.RIGHT);
		lblId.setBounds(20, 14, 111, 14);
		contentPanel.add(lblId);
		
		JLabel lblDigestMethod = new JLabel("Digest Method");
		lblDigestMethod.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDigestMethod.setBounds(10, 45, 121, 14);
		contentPanel.add(lblDigestMethod);
		
		JLabel lblDigestValue = new JLabel("Digest Value");
		lblDigestValue.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDigestValue.setBounds(10, 77, 121, 14);
		contentPanel.add(lblDigestValue);
		
		JLabel lblUri = new JLabel("URI");
		lblUri.setHorizontalAlignment(SwingConstants.RIGHT);
		lblUri.setBounds(10, 108, 121, 14);
		contentPanel.add(lblUri);
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addClick();
			}
		});
		btnAdd.setBounds(341, 169, 91, 23);
		contentPanel.add(btnAdd);
		
		btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteClick();
			}
		});
		btnDelete.setBounds(341, 203, 91, 23);
		contentPanel.add(btnDelete);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(20, 143, 311, 120);
		contentPanel.add(scrollPane);
		
		lbTransforms = new JTable();
		lbTransforms.setModel(new DefaultTableModel(
			new Object[][] {
			},
			new String[] {
				" "
			}
		));
		lbTransforms.getColumnModel().getColumn(0).setPreferredWidth(150);
		lbTransforms.getColumnModel().getColumn(0).setMinWidth(150);
		lbTransforms.setFillsViewportHeight(true);
		scrollPane.setViewportView(lbTransforms);
		
		cmbTransform = new JComboBox<String>();
		cmbTransform.setModel(new DefaultComboBoxModel<String>(new String[] {"Base64 transform", "Canonical transform", "Canonical with comments transform", "Minimal canonical transform", "Enveloped signature transform", "XPath transform"}));
		cmbTransform.setBounds(20, 274, 412, 22);
		contentPanel.add(cmbTransform);
		
		lbXPath = new JLabel("XPath expression");
		lbXPath.setBounds(20, 307, 111, 14);
		contentPanel.add(lbXPath);
		
		lbXPathNS = new JLabel("Namespaces");
		lbXPathNS.setBounds(40, 335, 91, 14);
		contentPanel.add(lbXPathNS);
		
		edXPath = new JTextField();
		edXPath.setBounds(134, 304, 298, 20);
		contentPanel.add(edXPath);
		edXPath.setColumns(10);
		
		edXPathNSMap = new JTextField();
		edXPathNSMap.setBounds(134, 332, 298, 20);
		contentPanel.add(edXPathNSMap);
		edXPathNSMap.setColumns(10);
		
		rbURINode = new JRadioButton("URI Node");
		rbURINode.setBounds(20, 366, 111, 23);
		contentPanel.add(rbURINode);
		
		edURINode = new JTextField();
		edURINode.setBounds(134, 367, 298, 20);
		contentPanel.add(edURINode);
		edURINode.setColumns(10);
		
		JLabel lblNamespaces_1 = new JLabel("Namespaces");
		lblNamespaces_1.setBounds(40, 396, 91, 14);
		contentPanel.add(lblNamespaces_1);
		
		edNSMap = new JTextField();
		edNSMap.setBounds(134, 393, 298, 20);
		contentPanel.add(edNSMap);
		edNSMap.setColumns(10);
		
		rbURIData = new JRadioButton("URI Data");
		rbURIData.setBounds(22, 431, 109, 23);
		contentPanel.add(rbURIData);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(20, 460, 412, 157);
		contentPanel.add(scrollPane_1);
		
		mmData = new JTextArea();
		scrollPane_1.setViewportView(mmData);
		
		JSeparator separator = new JSeparator();
		separator.setBounds(20, 360, 412, 2);
		contentPanel.add(separator);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			
			btnVerify = new JButton("Verify");
			btnVerify.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					verifyClick();
				}
			});
			btnVerify.setHorizontalAlignment(SwingConstants.LEFT);
			buttonPane.add(btnVerify);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void verifyClick() {
        byte[] dv;
        FReference.setURIData(SBUtils.bytesOfString(mmData.getText()));

        dv = FReference.getDigestValue();
        try
        {
            FReference.updateDigestValue();
        }
        catch (Exception E)
        {
            showErrorMessage(E.getMessage());
            return;
        }

        if (SBUtils.compareMem(FReference.getDigestValue(), dv))
            showMessage("", "Verified OK");
        else
            showMessage("", "BAD digest or data");

        FReference.setDigestValue(dv);
	}

	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	

	protected void deleteClick() {
        if (lbTransforms.getSelectedRowCount() >= 0)
            FReference.getTransformChain().delete(lbTransforms.getSelectedRow());

        updateDigestValue();
        updateTransformChain();		
	}

	protected void addClick() {
		String transform = (String)cmbTransform.getSelectedItem(); 
        if (transform.compareTo("Base64 transform") == 0)
            FReference.getTransformChain().add(new TElXMLBase64Transform());
        else if (transform.compareTo("Remove enveloped signature") == 0)
            FReference.getTransformChain().add(new TElXMLEnvelopedSignatureTransform());
        else if (transform.compareTo("XPath transform") == 0)
        {
            TElXMLXPathTransform XPathTransform = new TElXMLXPathTransform();
            XPathTransform.setXPath(edXPath.getText());

            String s = edXPathNSMap.getText().trim();
            while (s.compareTo("") != 0)
            {
                int i = s.indexOf(',');
                String t;
                if (i >= 0)
                {
                    t = s.substring(0, i).trim();
                    s = s.substring(i + 1).trim();
                }
                else
                {
                    t = s;
                    s = "";
                }

                i = t.indexOf('=');
                if (i >= 0)
                    XPathTransform.getNamespaceMap().addNamespace(t.substring(0, i).trim(), t.substring(i + 1).trim());
            }

            FReference.getTransformChain().add(XPathTransform);
        }
        else
        {
            TElXMLC14NTransform C14N = new TElXMLC14NTransform();
            if (transform.compareTo("Canonical transform") == 0)
            {
                C14N.setCanonicalizationMethod(SBXMLDefs.xcmCanon);
                FReference.getTransformChain().add(C14N);
            }
            else
                if (transform.compareTo("Canonical with comments transform") == 0)
                {
                    C14N.setCanonicalizationMethod(SBXMLDefs.xcmCanonComment);
                    FReference.getTransformChain().add(C14N);
                }
                else
                    if (transform.compareTo("Minimal canonical transform") == 0)
                    {
                        C14N.setCanonicalizationMethod(SBXMLDefs.xcmMinCanon);
                        FReference.getTransformChain().add(C14N);
                    }
        }

        updateDigestValue();
        updateTransformChain();
	}

	public void setReference(TElXMLReference value) {
        FReference = value;
        edID.setText(FReference.getID());
        edURI.setText(FReference.getURI());

        switch (FReference.getDigestMethod())
        {
            case SBXMLSec.xdmMD5:
                {
                    cmbDigestMethod.setSelectedIndex(0);
                    break;
                }
            case SBXMLSec.xdmSHA1:
                {
                    cmbDigestMethod.setSelectedIndex(1);
                    break;
                }
            case SBXMLSec.xdmSHA224:
                {
                    cmbDigestMethod.setSelectedIndex(2);
                    break;
                }
            case SBXMLSec.xdmSHA256:
                {
                    cmbDigestMethod.setSelectedIndex(3);
                    break;
                }
            case SBXMLSec.xdmSHA384:
                {
                    cmbDigestMethod.setSelectedIndex(4);
                    break;
                }
            case SBXMLSec.xdmSHA512:
                {
                    cmbDigestMethod.setSelectedIndex(5);
                    break;
                }
            case SBXMLSec.xdmRIPEMD160:
                {
                    cmbDigestMethod.setSelectedIndex(6);
                    break;
                }
        }

        FURINode = FReference.getURINode();
        updateURINode(FURINode);
        mmData.setText(SBUtils.stringOfBytes(FReference.getURIData()));

        rbURINode.setSelected(FURINode != null);

        if (FVerify)
        {
            if (FReference.getDigestValue().length > 0)
                edDigestValue.setText(SBUtils.binaryToString(FReference.getDigestValue()));
            else
                edDigestValue.setText("");
        }
        else
            updateDigestValue();

        updateTransformChain();
	}

	private void updateTransformChain() {
        clearTransformItems();
        for (int i = 0; i < FReference.getTransformChain().getCount(); i++)
        	addTransformItem(transformToStr(FReference.getTransformChain().getTransform(i)));

        edXPath.setEnabled((((String)cmbTransform.getSelectedItem()).compareTo("XPath transform") == 0));
        lbXPath.setEnabled(edXPath.isEnabled());
        lbXPathNS.setEnabled(edXPath.isEnabled());
        edXPathNSMap.setEnabled(edXPath.isEnabled());	
	}

	private void addTransformItem(String value) {
		DefaultTableModel model = (DefaultTableModel)lbTransforms.getModel();
		model.insertRow(model.getRowCount(), new Object[] { value });
	}

	private String transformToStr(TElXMLTransform value) {
        if (value instanceof TElXMLBase64Transform)
            return "Base64 transform";
        else
            if (value instanceof TElXMLC14NTransform)
            {
                if (((TElXMLC14NTransform)value).getCanonicalizationMethod() == SBXMLDefs.xcmCanon)
                    return "Canonical transform";
                else
                    if (((TElXMLC14NTransform)value).getCanonicalizationMethod() == SBXMLDefs.xcmCanonComment)
                        return "Canonical with comments transform";
                    else
                        if (((TElXMLC14NTransform)value).getCanonicalizationMethod() == SBXMLDefs.xcmMinCanon)
                            return "Minimal canonical transform";
            }
            else if (value instanceof TElXMLEnvelopedSignatureTransform)
                return "Remove enveloped signature";
            else if (value instanceof TElXMLXPathTransform)
                return "XPath transform";

        return "Unknown transform";
	}

	private void clearTransformItems() {
		((DefaultTableModel)lbTransforms.getModel()).setNumRows(0);
	}

	private void updateDigestValue() {
        if (FVerify)
            return;

        try
        {
            FReference.updateDigestValue();
            if (FReference.getDigestValue().length > 0)
                edDigestValue.setText(SBUtils.binaryToString(FReference.getDigestValue()));
            else
                edDigestValue.setText("");
        }
        catch (Exception ex)
        {
            edDigestValue.setText("");
        }
	}

	private void updateURINode(TElXMLDOMNode Node) {
        if (Node == null)
        {
            edURINode.setText("");
            edNSMap.setText("");
            return;
        }

        TElXMLNamespaceMap NSMap = new TElXMLNamespaceMap();
        String Path = "";
        String s;
        while (!(Node instanceof TElXMLDOMDocument))
        {
            int i = 0;
            TElXMLDOMNode PrevNode = Node.getPreviousSibling();
            while (PrevNode != null)
            {
                if ((PrevNode.getNodeName().compareTo(Node.getNodeName()) == 0) && (PrevNode.getNamespaceURI().compareTo(Node.getNamespaceURI()) == 0))
                    i++;

                PrevNode = PrevNode.getPreviousSibling();
            }

            s = Node.getLocalName();
            if (Node.getNamespaceURI().compareTo("") != 0)
            {
                String p = "";
                if (Node.getPrefix().compareTo("") != 0)
                {
                    p = Node.getPrefix();
                    if (NSMap.findNamespace(p).compareTo(Node.getNamespaceURI()) != 0)
                    {
                        if (NSMap.findNamespace(p) == "")
                            NSMap.addNamespace(p, Node.getNamespaceURI());
                        else
                            p = "";
                    }
                }

                if (p == "")
                {
                    for (int k = 0; k < NSMap.getCount(); k++)
                        if (NSMap.getURI(k) == Node.getNamespaceURI())
                        {
                            p = NSMap.getPrefix(k);
                            break;
                        }

                    if (p == "")
                    {
                        p = "x";
                        int k = 1;
                        while (NSMap.findNamespace(p) != "")
                        {
                            k++;
                            p = "x" + k;
                        }
                    }

                    NSMap.addNamespace(p, Node.getNamespaceURI());
                }

                s = p + ":" + s;
            }

            if (i > 0)
                Path = "/" + s + "[" + (i + 1) + "]" + Path;
            else
                Path = "/" + s + Path;

            Node = Node.getParentNode();
        }

        if (Path == "")
            Path = "/";

        s = "";
        for (int i = 0; i < NSMap.getCount(); i++)
            if ((NSMap.getPrefix(i) != "") && (NSMap.getPrefix(i) != "xml"))
            {
                if (s != "")
                    s = s + ", ";

                s = s + NSMap.getPrefix(i) + "=" + NSMap.getURI(i);
            }

        edURINode.setText(Path);
        edNSMap.setText(s);
    }

	public void setVerify(boolean value) {
        FVerify = value;
        btnAdd.setEnabled(!FVerify);
        btnDelete.setEnabled(!FVerify);
        edID.setEditable(FVerify);
        edURI.setEditable(FVerify);
        btnVerify.setVisible(FVerify);
	}

	public boolean isOK() {
		return isOk;
	}

	public TElXMLReference getReference() {
        FReference.setID(edID.getText());
        FReference.setURI(edURI.getText());
        return FReference;
	}

	public void setDocument(TElXMLDOMDocument doc) {
		Document = doc;
	}
}
