import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElX509Certificate;

public class WinCertDataRow {
	public String CertID;
	public String IssuedTo;
	public String IssuedBy;
	public String ValidFrom;
	public String ValidTo;
	public String PrivateKey;
	public TElX509Certificate Tag;
	
	public WinCertDataRow(TElX509Certificate Cert) {
		Tag = Cert;
		// Serial Number
		CertID = SBUtils.beautifyBinaryString(SBUtils.binaryToString(Cert.getSerialNumber()), ' ');
		// Subject
		String s = Cert.getSubjectName().CommonName;
		if (s == "")
			s = Cert.getSubjectName().Organization;
		IssuedTo = s;
		// Issuer
		IssuedBy = Cert.getIssuerName().CommonName;
		if (IssuedBy == "")
			IssuedBy = Cert.getIssuerName().Organization;

		// Valid From
		ValidFrom = Cert.getValidFrom().toString();
		// Valid To
		ValidTo = Cert.getValidTo().toString();

		if (Cert.getPrivateKeyExists())
			PrivateKey = "Yes";
		else
			PrivateKey = "No";
	}
}