
import SecureBlackbox.Base.SBChSConv;
import SecureBlackbox.Base.SBChSConvCharsets;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.ZIP.SBArcTar;
import SecureBlackbox.ZIP.TElGZipWriter;
import SecureBlackbox.ZIP.TSBGZipProgressEvent;
import SecureBlackbox.ZIP.TSBGZipUserActionNeededEvent;
import org.freepascal.rtl.TObject;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public class Main {

	private JFrame frmGZipArchivier;
    private final JPanel contentPanel = new JPanel();
    private JTextField textArchiveName;
    private JTextField textArchiveSize;
    private JTextField textFileName;
    private JTextField textFileSize;

    private JButton btnClose;
    private JButton btnAdd;
    private JButton btnExtract;
    private JButton btnExtract1;
    private JButton btnSave;
    private JButton btnSaveAs;

	String extractToPath;
    String extractToFile;
	TElGZipWriter elGZipWriter;

	String newArchiveName;
    String saveArchiveName;
	String openedArchiveName;

	ProgressDialog progressForm;	
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frmGZipArchivier.setVisible(true);
				} catch (Exception e) {
					showErrorMessage("Error", e.getMessage());
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
		initGZipWriterEvents();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
        #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
        SBUtils.setLicenseKey("<put the key here>");
		
 		SBChSConvCharsets.initialize();

        elGZipWriter = new TElGZipWriter();

        frmGZipArchivier = new JFrame();
        frmGZipArchivier.setTitle("GZip Archivier");
        frmGZipArchivier.setBounds(100, 100, 485, 290);
        frmGZipArchivier.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frmGZipArchivier.getContentPane().setLayout(new BorderLayout());
        contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
        frmGZipArchivier.getContentPane().add(contentPanel, BorderLayout.CENTER);
        contentPanel.setLayout(null);

        JButton btnNew = new JButton("New archive");
        btnNew.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newArchive();
            }
        });
        btnNew.setBounds(20, 20, 110, 30);
        contentPanel.add(btnNew);

        JButton btnOpen = new JButton("Open archive");
        btnOpen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                openArchive();
            }
        });
        btnOpen.setBounds(140, 20, 110, 30);
        contentPanel.add(btnOpen);

        btnClose = new JButton("Close archive");
        btnClose.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                closeArchive();
            }
        });
        btnClose.setBounds(345, 20, 115, 30);
        btnClose.setEnabled(false);
        contentPanel.add(btnClose);

        JLabel lblArchiveName = new JLabel("Archive name");
        lblArchiveName.setBounds(20, 70, 80, 13);
        contentPanel.add(lblArchiveName);

        textArchiveName = new JTextField();
        textArchiveName.setBounds(105, 67, 249, 20);
        textArchiveName.setEditable(false);
        contentPanel.add(textArchiveName);

        JLabel lblArchiveSize = new JLabel("Size");
        lblArchiveSize.setBounds(381, 70, 27, 13);
        contentPanel.add(lblArchiveSize);

        textArchiveSize = new JTextField();
        textArchiveSize.setBounds(413, 67, 47, 20);
        textArchiveSize.setEditable(false);
        contentPanel.add(textArchiveSize);

        JLabel lblFileName = new JLabel("File name");
        lblFileName.setBounds(44, 114, 60, 13);
        contentPanel.add(lblFileName);

        textFileName = new JTextField();
        textFileName.setBounds(105, 111, 221, 20);
        textFileName.setEditable(false);
        contentPanel.add(textFileName);

        JLabel lblFileSize = new JLabel("File size");
        lblFileSize.setBounds(344, 114, 50, 13);
        contentPanel.add(lblFileSize);

        textFileSize = new JTextField();
        textFileSize.setBounds(397, 111, 63, 20);
        textFileSize.setEditable(false);
        contentPanel.add(textFileSize);


        btnAdd = new JButton("Add file");
        btnAdd.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                addFileToArchive();
            }
        });
        btnAdd.setBounds(20, 164, 80, 30);
        btnAdd.setEnabled(false);
        contentPanel.add(btnAdd);

        btnExtract = new JButton("Extract to");
        btnExtract.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                File fileName = getFileSaveAsName();
                if (fileName != null)
                  extractFile(fileName.getParent(), fileName.getName());
            }
        });
        btnExtract.setBounds(170, 164, 110, 30);
        btnExtract.setEnabled(false);
        contentPanel.add(btnExtract);

        btnExtract1 = new JButton("Extract with own name");
        btnExtract1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String directory = selectDirectory();
                if (directory != "")
                  extractFile(directory, "");
            }
        });
        btnExtract1.setBounds(295, 164, 165, 30);
        btnExtract1.setEnabled(false);
        contentPanel.add(btnExtract1);

        btnSave = new JButton("Save archive");
        btnSave.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                saveArchive();
            }
        });
        btnSave.setBounds(20, 215, 110, 30);
        btnSave.setEnabled(false);
        contentPanel.add(btnSave);

        btnSaveAs = new JButton("Save archive as");
        btnSaveAs.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                saveArchiveAs();
            }
        });
        btnSaveAs.setBounds(150, 215, 140, 30);
        btnSaveAs.setEnabled(false);
        contentPanel.add(btnSaveAs);
	}

	private void initGZipWriterEvents() {
        elGZipWriter.setOnUserActionNeeded(new TSBGZipUserActionNeededEvent(actionClbk));
        elGZipWriter.setOnProgress(new TSBGZipProgressEvent(progressClbk));
	}

	private void addFileToArchive() {
		File file = getFileName();

        if (file != null)
        {
            elGZipWriter.add(file.getPath());
            textFileName.setText(file.getName());
            textFileSize.setText(Long.toString(file.length()));

            btnSave.setEnabled(true);
            btnSaveAs.setEnabled(true);
        }
	}
	
	private String selectDirectory() {
		JFileChooser fc = new JFileChooser(); 
	    fc.setCurrentDirectory(new java.io.File("."));
	    fc.setDialogTitle("Select directory to extract files to");
	    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    fc.setAcceptAllFileFilterUsed(false);

	    if (fc.showOpenDialog(frmGZipArchivier) == JFileChooser.APPROVE_OPTION)
	    	return fc.getSelectedFile().getPath();
	    
	    return "";
	}

	File getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(frmGZipArchivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile();

	    return null;
	} 

	File getFileSaveAsName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(frmGZipArchivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile();

	    return null;
	}

	private void openArchive() {
        if (elGZipWriter.getOpened())
            elGZipWriter.close();

        File fileName = getFileName();
        if (fileName != null)
        {
            openedArchiveName = fileName.getPath();

            java.lang.Thread t = new java.lang.Thread(new Runnable() {
                public void run() {
                    try
                    {
                        elGZipWriter.open(openedArchiveName, false);
                    }
                    catch (Exception ex)
                    {
                        showErrorMessage("Error opening archive", ex.getMessage());
                    }

                    if (elGZipWriter.getOpened())
                    {
                        btnClose.setEnabled(true);
                        btnAdd.setEnabled(true);
                        btnExtract.setEnabled(true);
                        btnExtract1.setEnabled(true);

                        textArchiveName.setText(openedArchiveName);
                        textArchiveSize.setText(Long.toString(elGZipWriter.getCompressedSize()));
                        textFileName.setText(elGZipWriter.getAttributes().getFileName());
                        textFileSize.setText(Long.toString(elGZipWriter.getAttributes().getFileSize()));
                    };
                }
            });

            t.start();
        }
	}

	static void showErrorMessage(String caption, String msg){
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.ERROR_MESSAGE);
	}
	
	private void closeArchive() {
		if (elGZipWriter.getOpened())
		{
            elGZipWriter.close();

            btnClose.setEnabled(false);
            btnAdd.setEnabled(false);
            btnSave.setEnabled(false);
            btnSaveAs.setEnabled(false);
            btnExtract.setEnabled(false);
            btnExtract1.setEnabled(false);

            textArchiveName.setText("");
            textArchiveSize.setText("");
            textFileName.setText("");
            textFileSize.setText("");
		}
	}

	private void createNewArchive(ArchiveOptionsDialog src) {
        newArchiveName = src.getNewArchiveFullPath();

        elGZipWriter.createArchive();

        elGZipWriter.setCompressionLevel(src.getCompressionLevel());

        btnClose.setEnabled(true);
        btnAdd.setEnabled(true);

        textArchiveName.setText(newArchiveName);
		textArchiveSize.setText("0");
        textFileName.setText("");
        textFileSize.setText("");

		addFileToArchive();
	}

	private void newArchive() {
		closeArchive();
		
		ArchiveOptionsDialog dlg = new ArchiveOptionsDialog();
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.getIsCreateArch())
			createNewArchive(dlg);
	}

	private void saveArchiveAs() {
		saveArchiveName = getFileSaveAsName().getPath();

        if (saveArchiveName != "") {
            progressForm = new ProgressDialog();

            progressForm.setCaptionText("Compressing...");
            progressForm.setButtonOKEnabled(false);
            progressForm.setButtonCancelEnabled(true);
            progressForm.setCancelOperation(false);

            progressForm.setCurrentFileName(saveArchiveName);
            progressForm.setProgressBarCurrentFile(0);

            progressForm.setVisible(true);

            java.lang.Thread t = new java.lang.Thread(new Runnable() {
                public void run() {
                    try
                    {
                        elGZipWriter.compress(saveArchiveName);

                        textArchiveSize.setText(Long.toString(elGZipWriter.getCompressedSize()));
                        progressForm.addToLog("File compressed : " + saveArchiveName);
                    }
                    catch (Exception ex)
                    {
                        showErrorMessage("Compression error", ex.getMessage());
                    }
                    finally
                    {
                        progressForm.setButtonCancelEnabled(false);
                        progressForm.setButtonOKEnabled(true);
                    }
                }
            });

            t.start();
        }
	}
	
	private void saveArchive() {
		
		progressForm = new ProgressDialog();

		progressForm.setCaptionText("Compressing...");
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);

        if (elGZipWriter.getNewArchive())
            progressForm.setCurrentFileName(newArchiveName);
        else
            progressForm.setCurrentFileName(openedArchiveName);
        progressForm.setProgressBarCurrentFile(0);

		progressForm.setVisible(true);
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
					if (elGZipWriter.getNewArchive())
                        elGZipWriter.compress(newArchiveName);
			        else
                        elGZipWriter.compress();

                    textArchiveSize.setText(Long.toString(elGZipWriter.getCompressedSize()));

                    if (elGZipWriter.getNewArchive())
                        progressForm.addToLog("File compressed : " + newArchiveName);
                    else
                        progressForm.addToLog("File compressed : " + openedArchiveName);
				}
				catch (Exception ex)
				{
					showErrorMessage("Compression error", ex.getMessage());
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
			}
		});
		
		t.start();
	}
	

	private void extractFile(String outputPath, String outputFile)
	{
		progressForm = new ProgressDialog();
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);
		progressForm.clearLog();
		progressForm.setCaptionText("Extracting...");

        if (outputFile == "")
        {
            progressForm.setCurrentFileName(elGZipWriter.getAttributes().getFileName());
        }
        else
        {
            progressForm.setCurrentFileName(outputFile);
        }
        progressForm.setProgressBarCurrentFile(0);

		progressForm.setVisible(true);
		
		extractToPath = outputPath;
        extractToFile = outputFile;
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
                    if (extractToFile == "")
                    {
                        elGZipWriter.extract(extractToPath, elGZipWriter.getAttributes().getFileName());
                        progressForm.addToLog("File extract : " + elGZipWriter.getAttributes().getFileName());
                    }
                    else
                    {
                        elGZipWriter.extract(extractToPath, extractToFile);
                        progressForm.addToLog("File extract : " + extractToFile);
                    }
				}
				catch (Exception ex)
				{
					progressForm.addToLog("Error extracting file: " + ex.getMessage());                
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
			}
		});
		
		t.start();
	}

	private int selectUserAction(String description) {
		int result = JOptionPane.showOptionDialog(null, description, "Warning", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, new String[] { "Abort", "Retry", "Ignore" }, null);
		
		if (result == 0)
			return SBArcTar.TAR_ACTION_ABORT;
		else if (result == 1)
			return SBArcTar.TAR_ACTION_RETRY;

		return SBArcTar.TAR_ACTION_IGNORE;
	}
	
	// events
	
	TSBGZipUserActionNeededEvent.Callback actionClbk = new TSBGZipUserActionNeededEvent.Callback() {
		public void tsbgZipUserActionNeededEventCallback(TObject sender, int forEvent, String description, TSBInteger action) {
			action.value = selectUserAction(description);
		}
	};
	
	TSBGZipProgressEvent.Callback progressClbk = new TSBGZipProgressEvent.Callback() {
		public void tsbgZipProgressEventCallback(TObject sender, long processed, long total, TSBBoolean cancel) {
			long processedNorm;
            if (total > 0)
                processedNorm = ((processed * 100000) / total);
            else
                processedNorm = 100000;
			progressForm.setProgressBarCurrentFile((int) processedNorm);

			cancel.value = progressForm.getCancelOperation();
		}
	};
}